﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SimpleWars
{
    class mSpecTools
    {

        // 获取所有自己单位，敌方单位，攻击位置的信息，以Action的List形式存储
        public static List<Action> getAllAttackActions(int teamcolor, Map map)
        {
            List<Action> atkActions = new List<Action>();

            // 我方单位行动可能的List
            List<Unit> myMovableUnits = map.getUnitsList(teamcolor, false, true, false);

            foreach (Unit myUnit in myMovableUnits)
            {
                // 行动可能单位的攻击行动的List
                List<Action> atkActionsOfOne = RangeController.getAttackActionList(myUnit, map);
                //包含整体
                atkActions.AddRange(atkActionsOfOne);
            }

            return atkActions;
        }

        public static void storeSpec(nodes node, Action a, Map map)
        {
            Unit opUnit = map.getUnit(a.operationUnitId);
            Unit targetUnit = map.getUnit(a.targetUnitId);

            node.opUnit_type = opUnit.getTypeOfUnit();
            node.targetUnit_type = targetUnit.getTypeOfUnit();
        }

        public static void storemoveSpec(nodes node, Action a, Map map)
        {
            Unit opUnit = map.getUnit(a.operationUnitId);

            node.opUnit_type = opUnit.getTypeOfUnit();

        }

        //获取所有可能的行动
        public static List<Action> getAllMoveActions(int teamcolor, Map map)
        {
            List<Action> moveActions = new List<Action>();

            //我方行动可能的单位的列表
            List<Unit> myMovableUnits = map.getUnitsList(teamcolor, false, true, false);

            //归纳移动可能的单位移动可能的位置入列表List
            foreach (Unit myUnit in myMovableUnits)
            {
                bool[,] reachable = RangeController.getReachableCellsMatrix(myUnit, map);
                for (int i = 0; i < reachable.GetLength(0); i++)
                {
                    for (int j = 0; j < reachable.GetLength(1); j++)
                    {
                        if (reachable[i, j])
                        {
                            moveActions.Add(Action.createMoveOnlyAction(myUnit, i, j));
                        }
                    }
                }
            }

            return moveActions;
        }

        public static bool isEffective(Unit operationUnit, Unit targetUnit)
        {
            if (operationUnit.getSpec().getUnitAtkPower(targetUnit.getTypeOfUnit()) != 0) { return true; }
            return false;
        }


        public static List<Action> getAllActions(int teamColor, Map map)
        {
            List<Action> allActions = new List<Action>();

            allActions.AddRange(getAllAttackActions(teamColor, map));
            allActions.AddRange(getAllMoveActions(teamColor, map));

            return allActions;
        }        

    }
}
